import csv
from pprint import pprint

#open files and use dictreader to cache information
file1 = open("sales_by_customer_month_store.csv", mode='r', encoding='utf-8-sig')
file2 = open("customer_info.csv", mode='r', encoding='utf-8-sig')
csv_sales = csv.DictReader(file1, delimiter=";")
csv_customer = csv.DictReader(file2, delimiter=";")

#select only customers born in USA
customers_usa_gender = dict()
for line in csv_customer:
    if line["country"] == "USA":
        customer_id = int(line["customer_id"])
        customers_usa_gender[customer_id] = line["gender"]
file2.close()

#groupby and sum
store_gender_info = dict()
for line in csv_sales:
    customer_id = int(line["customer_id"])
    if customer_id in customers_usa_gender:
        store_id = int(line["store_id"])
        if store_id not in store_gender_info:
            store_gender_info[store_id] = dict()

        gender_info = store_gender_info[store_id]
        gender = customers_usa_gender[customer_id]
        if gender not in gender_info:
            gender_info[gender] = {"total_sales": 0, "distinct_months": set()}

        month_of_year = int(line["month_of_year"])
        gender_info[gender]["total_sales"] += float(line["total_sales"])
        gender_info[gender]["distinct_months"].add(month_of_year)
file1.close()

#caclulating yearly average
for store in store_gender_info:
    for gender in store_gender_info[store]:
        info = store_gender_info[store][gender]
        info["yearly_average"] = info["total_sales"] / len(info["distinct_months"])
        keys = ["yearly_average"]

        for key in keys:
            new_dict[key] = info[key]

        new_dict = {key: info[key] for key in keys}
        store_gender_info[store][gender] = new_dict

pprint(store_gender_info)
